## ros-lunar-rosmon 1.0.10

=== CMakeLists.txt ===

cmake_minimum_required(VERSION 2.8)
project(rosmon)

find_package(catkin REQUIRED COMPONENTS
	roscpp
	cmake_modules
	roslib
	message_generation
	pluginlib
	rospack
	rqt_gui
	rqt_gui_cpp
)

add_message_files(FILES
	NodeState.msg
	State.msg
)

add_service_files(FILES
	StartStop.srv
)

generate_messages(DEPENDENCIES
	std_msgs
)

catkin_package()

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -Werror")

find_package(TinyXML REQUIRED)

find_package(Curses REQUIRED)
include_directories(${CURSES_INCLUDE_DIRS})

# We search for the same Python version that catkin has decided on.
# Source: https://github.com/ros/rospack/blob/70eac5dec07311f9cacccddb301a8bc9b4efb671/CMakeLists.txt#L6
set(Python_ADDITIONAL_VERSIONS "${PYTHON_VERSION_MAJOR}.${PYTHON_VERSION_MINOR}")
find_package(PythonLibs "${PYTHON_VERSION_MAJOR}.${PYTHON_VERSION_MINOR}" QUIET)
if(PYTHONLIBS_FOUND)
	add_definitions(-DHAVE_PYTHON=1)
	include_directories(${PYTHON_INCLUDE_DIRS})
else()
	message(WARNING "Please install libpython-dev (or equivalent) for $(eval ...) support")
endif()

find_package(Boost REQUIRED COMPONENTS python REQUIRED)
include_directories(${Boost_INCLUDE_DIRS})

# Specific feature tests
if(${roscpp_VERSION} VERSION_GREATER 1.12.8)
	message(STATUS "roscpp is new enough, using SteadyTimer for timekeeping")
	add_definitions(-DHAVE_STEADYTIMER=1)
endif()

if(${pluginlib_VERSION} VERSION_GREATER 1.11.1)
	message(STATUS "using new pluginlib headers with .hpp extensions")
	add_definitions(-DHAVE_PLUGINLIB_NEW_HEADERS=1)
endif()

# Are we building with test coverage instrumentation?
set(BUILD_FOR_COVERAGE OFF CACHE BOOL "Build with coverage instrumentation?")
if(BUILD_FOR_COVERAGE)
	if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fprofile-instr-generate -fcoverage-mapping")
	else()
		message(WARNING "Coverage build is only supported with clang")
	endif()
endif()

add_subdirectory(contrib/fmt)

add_library(rosmon_launch_config
	src/launch/node.cpp
	src/launch/launch_config.cpp
	src/launch/substitution.cpp
	src/launch/substitution_python.cpp
	src/launch/yaml_params.cpp
	src/package_registry.cpp
)
target_link_libraries(rosmon_launch_config
	${catkin_LIBRARIES}
	${TinyXML_LIBRARIES}
	${Boost_LIBRARIES}
	${Python_LIBRARIES}
	rosmon_fmt
	yaml-cpp
)

add_executable(rosmon
	src/main.cpp
	src/monitor/node_monitor.cpp
	src/monitor/monitor.cpp
	src/monitor/linux_process_info.cpp
	src/ui.cpp
	src/husl/husl.c
	src/ros_interface.cpp
	src/fd_watcher.cpp
	src/logger.cpp
	src/terminal.cpp
)
target_link_libraries(rosmon
	${catkin_LIBRARIES}
	${TinyXML_LIBRARIES}
	${CURSES_LIBRARIES}
	${Boost_LIBRARIES}
	yaml-cpp
	util
	rosmon_launch_config
)
add_dependencies(rosmon
	${PROJECT_NAME}_generate_messages_cpp
)

if(PYTHONLIBS_FOUND)
	target_link_libraries(rosmon
		${PYTHON_LIBRARIES}
	)
endif()

# GUI

# Decide on a Qt version
if("${qt_gui_cpp_USE_QT_MAJOR_VERSION} " STREQUAL "5 ")
	set(USE_QT5 true)
else()
	set(USE_QT5 false)
endif()

# Find Qt
if(USE_QT5)
	find_package(Qt5Widgets REQUIRED)
	set(QT_FOUND ${Qt5Widgets_FOUND})
	set(QT_LIBRARIES ${Qt5Widgets_LIBRARIES})
else()
	find_package(Qt4 COMPONENTS QtCore QtGui REQUIRED)
	include(${QT_USE_FILE})
endif()

find_package(rqt_gui_cpp)

if(QT_FOUND AND rqt_gui_cpp_FOUND)

	include_directories(${rqt_gui_cpp_INCLUDE_DIRS})
	include_directories(${CMAKE_CURRENT_BINARY_DIR})

	set(UI_FILES
		src/gui/mon_gui.ui
	)
	set(H_FILES
		src/gui/mon_gui.h
		src/gui/node_model.h
		src/gui/rosmon_model.h
	)

	if(USE_QT5)
		qt5_wrap_ui(UIC_FILES ${UI_FILES})
		qt5_wrap_cpp(MOC_FILES ${H_FILES})
	else()
		qt4_wrap_ui(UIC_FILES ${UI_FILES})
		qt4_wrap_cpp(MOC_FILES ${H_FILES})
	endif()

	add_library(rosmon_gui
		${UIC_FILES}
		${MOC_FILES}
		src/gui/bar_delegate.cpp
		src/gui/format_data_size.cpp
		src/gui/mon_gui.cpp
		src/gui/node_model.cpp
		src/gui/rosmon_model.cpp
	)
	target_link_libraries(rosmon_gui
		${catkin_LIBRARIES}
		${rqt_gui_cpp_LIBRARIES}
		${QT_LIBRARIES}
	)
	add_dependencies(rosmon_gui
		${PROJECT_NAME}_generate_messages_cpp
	)

	install(TARGETS rosmon_gui
		LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
	)
endif()

# Utils
add_executable(abort
	src/util/abort.cpp
)

add_executable(abort_really_long_executable
	src/util/abort.cpp
)

# Register unit tests
if(CATKIN_ENABLE_TESTING)
	# Integration tests
	find_package(rostest REQUIRED)
	add_rostest(test/basic.test DEPENDENCIES rosmon)

	# XML parsing test suite
	find_package(catch_ros)
	if(catch_ros_FOUND)
		include_directories(${catch_ros_INCLUDE_DIRS})

		catch_add_test(test_xml_loading
			test/xml/node_utils.cpp
			test/xml/test_arg.cpp
			test/xml/test_env.cpp
			test/xml/test_basic.cpp
			test/xml/test_if_unless.cpp
			test/xml/test_include.cpp
			test/xml/test_node.cpp
			test/xml/test_param.cpp
			test/xml/test_remap.cpp
			test/xml/test_rosparam.cpp
			test/xml/test_subst.cpp
		)
		target_link_libraries(test_xml_loading
			rosmon_launch_config
			${catch_ros_LIBRARIES}
		)
	else()
		message(WARNING "Install catch_ros to enable XML unit tests")
	endif()
endif()

# Version 1.4 (increment this comment to trigger a CMake update)
catkin_add_env_hooks(50-rosmon
	SHELLS bash zsh
	DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/env-hooks
)

install(TARGETS rosmon rosmon_launch_config
	LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
	RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

install(FILES rqt_plugin.xml
	DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
)

=== contrib/fmt/CMakeLists.txt ===

add_library(rosmon_fmt
	src/format.cc
	src/posix.cc
)

target_include_directories(rosmon_fmt PUBLIC
	${CMAKE_CURRENT_SOURCE_DIR}/include
)

install(TARGETS rosmon_fmt
	LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
	RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

=== debian/changelog ===
ros-lunar-rosmon (1.0.10-0stretch) stretch; urgency=high

  * main: exit gracefully on SIGTERM and SIGHUP as well (issue #59, PR #60)
  * launch: allow <arg default="XY"> in <include> tags (issue #57, PR #58)
    roslaunch allows this, so we should as well. Since it seems a bit
    confusing, we issue a warning when this happens.
    In these cases, <arg value="XY"> should be applicable and is much clearer.
  * Contributors: Max Schwarz

 -- Max Schwarz <max.schwarz@uni-bonn.de>  Sun, 28 Oct 2018 23:00:00 -0000

ros-lunar-rosmon (1.0.9-0stretch) stretch; urgency=high

  * Fix race condition in integration test (issue #42, PR #54)
  * Clean namespace names properly to fix double slashes (issue #49, PR #53)
  * Respect ROS_NAMESPACE for nested launches (issue #46, PR #51)
  * gui: Sort Memory column correctly (issue #48, PR #50)
  * Try to find an executable *file* for nodes (issue #45, PR #47)
  * Add --stop-timeout option and launch file attribute (PR #37)
  * Handle params with leading slashes inside nodes (PR #40)
  * Add --no-start option (PR #39)
  * gui: Fix index bug in showContextMenu (PR #38)
  * Contributors: Max Schwarz, Nikos Skalkotos, Romain Reignier

 -- Max Schwarz <max.schwarz@uni-bonn.de>  Wed, 19 Sep 2018 22:00:00 -0000

ros-lunar-rosmon (1.0.8-0stretch) stretch; urgency=high

  * main: Add option for flushing the logfile
    Add --flush option that will flush the logfile after each entry.
  * Merge pull request #35 <https://github.com/xqms/rosmon/issues/35>
    More complete support for rosparam features
  * Merge pull request #34 <https://github.com/xqms/rosmon/issues/34>
    YAML quoted strings
  * launch: rosparam: support binary data
  * launch: rosparam: correctly handle explicit YAML type tags
  * launch: support rosparam angle computations
  * launch: always map YAML quoted values to string params
    These always get mapped to str by python's yaml.load, which is used by
    roslaunch, so we do the same here.
  * Contributors: Max Schwarz, Nikos Skalkotos

 -- Max Schwarz <max.schwarz@uni-bonn.de>  Mon, 06 Aug 2018 22:00:00 -0000

ros-lunar-rosmon (1.0.7-0stretch) stretch; urgency=high

  * Support Python 3 & select appropriate Python version.
    This fixes a mismatch on Debian Jessie, where rospack is linked against
    Python 2.7 and we would link against Python 3.4.
  * launch: substitution_python: support Python 3
  * Contributors: Max Schwarz

 -- Max Schwarz <max.schwarz@uni-bonn.de>  Sat, 26 May 2018 22:00:00 -0000

ros-lunar-rosmon (1.0.6-0stretch) stretch; urgency=high

  * test/xml: replace more multiline string Catch captures
    Sorry, somehow these slipped through - and I didn't have a good way of
    testing these locally without the buildfarm. I'm testing with gcc 4.8
    on trusty now, which seems to have matching behavior.
  * Contributors: Max Schwarz

 -- Max Schwarz <max.schwarz@uni-bonn.de>  Fri, 25 May 2018 22:00:00 -0000

ros-lunar-rosmon (1.0.5-0stretch) stretch; urgency=high

  * test/xml: avoid multiline Catch captures in exception tests
    These trigger some weird bug between g++ 5.4 and ccache, which is used
    in the ROS buildfarm. [...]
    This should fix compilation on the build farm.
  * Contributors: Max Schwarz

 -- Max Schwarz <max.schwarz@uni-bonn.de>  Thu, 24 May 2018 22:00:00 -0000

ros-lunar-rosmon (1.0.4-0stretch) stretch; urgency=high

  * Merge pull request #30 <https://github.com/xqms/rosmon/issues/30> from xqms/feature/global_remap
    Support <remap> in other scopes than <node>. Fixes #28 <https://github.com/xqms/rosmon/issues/28>.
  * Merge pull request #29 <https://github.com/xqms/rosmon/issues/29> from xqms/feature/fmt
    Port all string formatting to fmt
  * update README.md, refer to ROS wiki
    Otherwise we duplicate the information.
  * launch: keep pointer to current element in ParseContext
    This is in preparation for a refactoring of the error handling code. This
    way, we don't have to explicitly pass line number information around - we
    can instead pull it from the ParseContext when the error is generated.
  * Merge pull request #27 <https://github.com/xqms/rosmon/issues/27> from xqms/feature/spec_tests
    roslaunch/XML spec unit tests
  * launch: launch_config: error on <include clear_params="true" />
    Even the roslaunch/XML spec says this is "extremely dangerous". We will
    explicitly *not* support that one for now.
  * launch: substitution_python: fix type deduction
    py::extract actually includes automatic conversion, so it is not
    appropriate for checking the returned object type. Use Python API instead.
  * launch: handle <node clear_params="true"> attribute
  * launch: launch_config: add support for <node cwd="..." />
  * launch: launch_config: node uniqueness check should consider namespaces
  * launch: substitution_python: report python exceptions more completely
  * launch: launch_config: error if node name is not unique
  * launch: launch_config: accept True/False as boolean values as well
    We are lenient here and accept the pythonic forms "True" and "False"
    as well, since roslaunch seems to do the same. Even the roslaunch/XML
    spec mentions True/False in the examples, even though they are not
    valid options for if/unless and other boolean attributes...
    http://wiki.ros.org/roslaunch/XML/rosparam
  * launch_config: add check for invalid <param> combinations
  * xml: param: test robustness against malformed tags
  * launch: launch_config: propagate exceptions from lazy param threads
    .. to main thread.
  * launch: launch_config: check if <param> commands exit normally
  * launch_config: handle binfile
  * launch: handle type "yaml" parameters (new in roslaunch since Lunar)
    This is actually a bit complicated, since this breaks a previous assumption
    we made: Our lazy evaluation of parameters depend on a 1:1 mapping of
    parameter names to jobs - this is not the case with YAML parameters, since


=== debian/control ===
Source: ros-lunar-rosmon
Section: misc
Priority: extra
Maintainer: Max Schwarz <max.schwarz@uni-bonn.de>
Build-Depends: debhelper (>= 9.0.0), libboost-all-dev, libncurses5-dev, libyaml-cpp-dev, python-dev, python-rospkg, qtbase5-dev, ros-lunar-catch-ros, ros-lunar-catkin, ros-lunar-cmake-modules, ros-lunar-message-generation, ros-lunar-rosbash, ros-lunar-roscpp, ros-lunar-roslib, ros-lunar-rospack, ros-lunar-rostest, ros-lunar-rqt-gui, ros-lunar-rqt-gui-cpp, ros-lunar-std-msgs
Homepage: 
Standards-Version: 3.9.2

Package: ros-lunar-rosmon
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libboost-all-dev, libncurses5-dev, libyaml-cpp-dev, ros-lunar-cmake-modules, ros-lunar-message-generation, ros-lunar-rosbash, ros-lunar-roscpp, ros-lunar-roslib, ros-lunar-rospack, ros-lunar-rqt-gui, ros-lunar-rqt-gui-cpp, ros-lunar-std-msgs
Description: Node launcher and monitor for ROS.
 rosmon is a replacement for the roslaunch tool, focused on performance, remote monitoring, and usability.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/lunar/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/lunar/setup.sh" ]; then . "/opt/ros/lunar/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/lunar" \
		-DCMAKE_PREFIX_PATH="/opt/ros/lunar"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/lunar/setup.sh" ]; then . "/opt/ros/lunar/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/lunar/setup.sh" ]; then . "/opt/ros/lunar/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/lunar/setup.sh" ]; then . "/opt/ros/lunar/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-lunar-rosmon//opt/ros/lunar/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/lunar/setup.sh" ]; then . "/opt/ros/lunar/setup.sh"; fi && \
	dh_auto_install
